=== debian/changelog ===
llvm-toolchain-21 (1:21.1.0~+rc2-1~exp1) experimental; urgency=medium

  * Creation of the 21 branch
  * upload of the rc2 version
  * Try to use llvm-spirv-20

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 29 Jul 2025 17:24:17 +0200

llvm-toolchain-snapshot (1:21~++20250612091244+3f0cf742ac4e-1~exp1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * Remove llvm-gpu-loader like upstream
  * Remove libomptarget.devicertl.a as it seems it has been removed here
    https://github.com/llvm/llvm-project/pull/136359
  * Remove 0001-tools-clang-cmake-resolve-symlinks-in-ClangConfig.cmake.patch
    to see if it fixes: https://github.com/llvm/llvm-project/issues/132556
  * Also ship usr/lib/llvm-21/lib/amdgcn-amd-amdhsa/libompdevice.a
    usr/lib/llvm-21/lib/nvptx64-nvidia-cuda/libompdevice.a in
    libomp-21-dev
  * Lower flang python dep for Debian buster for apt.llvm.org
    lower-flang-py-dep.diff
  * Adjust the path to libomptarget*bc
  * revert a flang-rt change to fix
    https://github.com/llvm/llvm-project/issues/139220
  * Ship more clang-doc
  * Also install llvm-test-mustache-spec
  * Ship offload-arch as part of clang-tools-X-Y
    79cb6f05da37520949c006e26c5cef1826090d9d

  [ Matthias Klose ]
  * On ppc64el configure --with-long-double-format=ieee for upcoming distros.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 12 Jun 2025 09:14:29 +0200

llvm-toolchain-snapshot (1:21~++20250322080030+20b5728b7b1c-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/rules: Distinguish between openmp and offload architectures.
  * Update libclang1 symbols file.
  * Update libomp symbols file, using symvers.
  * d/t/control: Remove explicit dependency on libstdc++-N-dev.
  * d/rules: Simplify permission settings for generated debhelper files.
  * d/rules: There's no more CMakeOutput.log anymore.

  [ Sylvestre Ledru ]
  * Prepare version 21
  * Merge recent changes from 19 and 20
  * Use lld as a linker instead of gold
  * clang-21 recommends clang-tools-21
    https://github.com/llvm/llvm-project/issues/117333
  * Do not install libclc header anymore.
    See a2b05761724e5243056988d9d6bf1a5a94715b74
    "The libclc headers are an implementation detail and are not
    intended to be used by others as OpenCL headers"
  * remove libc rpc files following upstream change
    8437b7f5584765ad4f7885500647657714930fbb
  * Add llvm-ml64 as part of the llvm-X.Y
    3c657ceef9ced068b0c7bc2f1d5fb74250720f6c
  * Add llvm-gpu-loader as part of the llvm-X.Y
    221b0117fd21d45098ead779a040a4b939a5c84f

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 22 Mar 2025 08:01:26 +0100

llvm-toolchain-20 (1:20.1.0-1~exp2) experimental; urgency=medium

  * Merge changes from the 19 branch

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 09 Mar 2025 10:52:27 +0100

llvm-toolchain-20 (1:20.1.0-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 06 Mar 2025 14:40:09 +0100

llvm-toolchain-20 (1:20.1.0~+rc3-1~exp1) experimental; urgency=medium

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Feb 2025 08:17:03 +0100

llvm-toolchain-20 (1:20.1.0~+rc2-1~exp2) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * clang-20 recommends clang-tools-20
    https://github.com/llvm/llvm-project/issues/117333
  * remove old libomp-20-dev breaks/replaces
  * Cherry-pick upstream fix for issue 126358

  [ Matthias Klose ]
  * d/llvm-X.Y-linker-tools.links.in: Remove, no gold anymore. LP: #2098355.
  * d/rules: Simplify permission settings for generated debhelper files.
  * d/rules: There's no more CMakeOutput.log anymore.
  * d/libomp5-X.Y.symbols.in: Remove duplicate symbol.
  * d/rules: Update setting lld and gold archs.
  * d/rules: Don't use lld on ppc64, sparc64 and x32, apparently unsupported.
  * d/libclang-rt-X.Y-dev.install.in: Install liborc_rt* on loong64.
  * debian/patches/env-lld-package-metadata.diff: Update and re-enable.

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 14 Feb 2025 12:28:14 +0100

llvm-toolchain-20 (1:20.1.0~+rc2-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/t/control.in: Remove explicit dependency on libstdc++-N-dev.

  [ Sylvestre Ledru ]
  * new rc release
  * Disable env-lld-package-metadata.diff because of upstream changes

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 12 Feb 2025 13:23:30 +0100

llvm-toolchain-20 (1:20.1.0~+rc1-1~exp1) experimental; urgency=medium

  * First tag of 20.1.0
  * libLLVMOffload.so.20.0 => libLLVMOffload.so.20.1 to follow upstream change
  * Use lld as a linker instead of gold

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 03 Feb 2025 09:00:03 +0100

llvm-toolchain-20 (1:20~++20250130014317+8c2574832ed2-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/rules: Distinguish between openmp and offload architectures.
  * Update libclang1 symbols file.
  * Update libomp symbols file, using symvers.
  * d/t/control: Remove explicit dependency on libstdc++-N-dev.

  [ Sylvestre Ledru ]
  * Prepare the branch 20

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 30 Jan 2025 13:43:33 +0100

llvm-toolchain-snapshot (1:20~++20250107094038+ea14bdb0356c-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * bolt: Disable the check for /proc/self/map_files. Might not be available
    on build machines. LP: #2084316.
  * Fix compatibility with Python 3.13. Closes: #1084659.

  [ Sylvestre Ledru ]
  * New snapshot release
  * Install usr/lib/llvm-20/include/shared/rpc*.h in libllvmlibc-X.Y-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 07 Jan 2025 21:41:10 +0100

llvm-toolchain-snapshot (1:20~++20241212011120+0cbdad4bd239-1~exp1) experimental; urgency=medium

  * Only build libc on supported arch (for real)
  * Ship bolt-binary-analysis in bolt

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 12 Dec 2024 13:22:30 +0100

llvm-toolchain-snapshot (1:20~++20241205084449+66a0a081338d-1~exp1) experimental; urgency=medium


