## llvm-toolchain-21 21.1.0

=== debian/changelog ===
llvm-toolchain-21 (1:21.1.0-1) unstable; urgency=medium

  * New upstream release
  * I am not going to upload -20 in unstable to avoid the maintenance burden

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Aug 2025 10:47:13 +0200
