## llvm-toolchain-21 21.1.1

=== debian/changelog ===
llvm-toolchain-21 (1:21.1.1-1) unstable; urgency=medium

  * New upstream release
  * never use libunwind for libc++abi
    Thanks to Norbert Lange for the fix
  * Build compiler builtin for s390x

  [ Andres Salomon ]
  * Fix incorrect major version dependency in libc++-21-dev.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 20 Sep 2025 09:12:54 +0200
